Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.codec.language
Class Metaphone

    java.lang.Object
      org.apache.commons.codec.language.Metaphone

All Implemented Interfaces:
  Encoder, StringEncoder

    public class Metaphone

extends Object
implements StringEncoder

Encodes a string into a Metaphone value.

Initial Java implementation by William B. Brogden. December, 1997. Permission given by wbrogden for code to be used anywhere.

Hanging on the Metaphone by Lawrence Philips in Computer Language of Dec. 1990, p 39.

Note, that this does not match the algorithm that ships with PHP, or the algorithm found in the Perl Text:Metaphone-1.96. They have had undocumented changes from the originally published algorithm. For more information, see CODEC-57.

This class is conditionally thread-safe. The instance field `maxCodeLen` is mutable `setMaxCodeLen(int)` but is not volatile, and accesses are not synchronised. If an instance of the class is shared between threads, the caller needs to ensure that suitable synchronisation is used to ensure safe publication of the value between threads, and must not invoke `setMaxCodeLen(int)` after initial setup.

Version:
  $Id: Metaphone.java 1380307 2012-09-03 18:49:34Z tn $

Constructor Summary
`Metaphone()` Creates an instance of the Metaphone encoder

Method Summary
`Object` | `encode(Object obj)` Encodes an Object using the metaphone algorithm.
`String` | `encode(String str)` Encodes a String using the Metaphone algorithm.
`int` | `getMaxCodeLen()` Returns the maxCodeLen.
`boolean` | `isMetaphoneEqual(String str1, String str2)` Tests is the metaphones of two strings are identical.
`String` | `metaphone(String txt)` Find the metaphone value of a String.
`void` | `setMaxCodeLen(int maxCodeLen)` Sets the maxCodeLen.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Metaphone

    public Metaphone()

  Creates an instance of the Metaphone encoder

Method Detail

### metaphone

    public String metaphone(String txt)

  Find the metaphone value of a String. This is similar to the soundex algorithm, but better at finding similar sounding words. All input is converted to upper case. Limitations: Input format is expected to be a single ASCII word with only characters in the A - Z range, no punctuation or numbers.

  Parameters:
    `txt` - String to find the metaphone code for
  Returns:
    A metaphone code corresponding to the String supplied

### encode

    public Object encode(Object obj)
                  throws EncoderException

  Encodes an Object using the metaphone algorithm. This method is provided in order to satisfy the requirements of the Encoder interface, and will throw an EncoderException if the supplied object is not of type java.lang.String.

  Specified by:
    `encode` in interface `Encoder`
  Parameters:
    `obj` - Object to encode
  Returns:
    An object (or type java.lang.String) containing the metaphone code which corresponds to the String supplied.
  Throws:
    `EncoderException` - if the parameter supplied is not of type java.lang.String

### encode

    public String encode(String str)

  Encodes a String using the Metaphone algorithm.

  Specified by:
    `encode` in interface `StringEncoder`
  Parameters:
    `str` - String object to encode
  Returns:
    The metaphone code corresponding to the String supplied

### isMetaphoneEqual

    public boolean isMetaphoneEqual(String str1,
                                    String str2)

  Tests is the metaphones of two strings are identical.

  Parameters:
    `str1` - First of two strings to compare
    `str2` - Second of two strings to compare
  Returns:
    `true` if the metaphones of these strings are identical, `false` otherwise.

### getMaxCodeLen

    public int getMaxCodeLen()

  Returns the maxCodeLen.

  Returns:
    int

### setMaxCodeLen

    public void setMaxCodeLen(int maxCodeLen)

  Sets the maxCodeLen.

  Parameters:
    `maxCodeLen` - The maxCodeLen to set

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2012 The Apache Software Foundation. All Rights Reserved.